import { Component, ViewChild, Input, OnInit } from '@angular/core';
import { MatMenuTrigger, MatMenu, MenuPositionX, MenuPositionY, MatMenuItem } from '@angular/material/menu';
import { MenuItem } from 'src/app/shared/models/menuItem.model';

@Component({
  selector: 'app-context-menu',
  templateUrl: './context-menu.component.html',
  styleUrls: ['./context-menu.component.scss']
})

export class ContextMenuComponent implements OnInit {
  @Input() menuItems: Array<MenuItem>;
  /*      {
        title: 'Totto'
      },
      { title: 'item 2 - level 1' },
      { title: 'item 3 - level 1' }, */
  @ViewChild(MatMenuTrigger)
  contextMenu: MatMenuTrigger;

  public xPos: MenuPositionX;
  public yPos: MenuPositionY;

  contextMenuPosition = { x: '0px', y: '0px' };
  constructor() { }

  ngOnInit(): void {

  }

  onContextMenu(event: MouseEvent) {
    event.preventDefault();
    this.contextMenuPosition.x = event.clientX + 'px';
    this.contextMenuPosition.y = event.clientY + 'px';
    this.contextMenu.menu.focusFirstItem('mouse');
    this.contextMenu.openMenu();
  }
  onContextMenuAction(item: MenuItem) {
    alert(`Click on Action 1 for ${item.title}`);
  }
}
