import { NgModule, Optional, SkipSelf, Provider } from '@angular/core';
import { HttpClientModule, HttpClient } from '@angular/common/http';
import { InMemoryWebApiModule } from 'angular-in-memory-web-api';
import { FakeBackendService } from 'src/app/shared/services/fake-backend.service';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';


export const CORE_SERVICES: Provider[] = [

];

@NgModule({
  imports: [
    BrowserAnimationsModule,
    HttpClientModule,
    InMemoryWebApiModule.forRoot(FakeBackendService),
  ],
  providers: CORE_SERVICES
})
export class CoreModule {
  constructor(
    @Optional()
    @SkipSelf()
    parentModule: CoreModule
  ) {
    if (parentModule) {
      throw new Error(
        'CoreModule is already loaded. Import it in the AppModule only'
      );
    }
  }
}
