import { Injectable } from '@angular/core';
import { InMemoryDbService } from 'angular-in-memory-web-api';
import { Sign } from 'src/app/shared/models/sign.model';
import { Acquisition } from 'src/app/shared/models/acquisition.model';
import { Command } from 'src/app/shared/models/command.model';
import { Condition } from 'src/app/shared/models/condition.model';



@Injectable({
  providedIn: 'root'
})
export class FakeBackendService implements InMemoryDbService {

  constructor() { }

  createDb() {

    const acqData = [

      {
        id: 1,
        signal: 'lamp1Status_on',
        value: true,
        isValid: true
      },
      {
        id: 2,
        signal: 'lamp2Status_on',
        value: false,
        isValid: true
      },
      {
        id: 3,
        signal: 'lamp3Status_on',
        value: true,
        isValid: false
      },
      {
        id: 4,
        signal: 'lamp4Status_on',
        value: false,
        isValid: false
      },
      {
        id: 5,
        signal: 'analog1_meas',
        value: 34.56,
        isValid: true
      },
      {
        id: 6,
        signal: 'analog2_meas',
        value: -32.98,
        isValid: true
      },
      {
        id: 7,
        signal: 'analog3_meas',
        value: -7777.00,
        isValid: false
      },
      {
        id: 8,
        signal: 'analog4_meas',
        value: 45,
        isValid: false
      },
      {
        id: 9,
        signal: 'digital1_meas',
        value: 666,
        isValid: true
      },
      {
        id: 10,
        signal: 'digital2_meas',
        value: -32,
        isValid: true
      },
      {
        id: 11,
        signal: 'digital3_meas',
        value: -7777,
        isValid: false
      },
      {
        id: 12,
        signal: 'digital4_meas',
        value: 23,
        isValid: false
      }
    ];
    const cmdData = [

      {
        id: 1,
        signal: 'switch1_on',
        value: false,
        isValid: true
      },
      {
        id: 2,
        signal: 'switch2_on',
        value: true,
        isValid: true
      },
      {
        id: 3,
        signal: 'switch3_on',
        value: false,
        isValid: false
      },
      {
        id: 4,
        signal: 'switch4_on',
        value: true,
        isValid: false
      },
      {
        id: 5,
        signal: 'switch1_off',
        value: true,
        isValid: true
      },
      {
        id: 6,
        signal: 'switch2_off',
        value: false,
        isValid: true
      },
      {
        id: 7,
        signal: 'switch3_off',
        value: true,
        isValid: false
      },
      {
        id: 8,
        signal: 'switch4_off',
        value: false,
        isValid: false
      }
    ];

    return { acqData, cmdData };
  }
}

