import { createAction, props } from '@ngrx/store';
import { Acquisition } from 'src/app/shared/models/acquisition.model';

export enum AcquisitionActionTypes {
    LOAD_ALL_ACQUISITIONS = '[Acquisition] Load all acquisitions',
    LOAD_ALL_ACQUISITIONS_SUCCESS = '[Acquisition] Load all acquisitions success',
    ACQUISITION_FAILED = '[Acquisition] failure',
}
export const loadAllAcquisitions = createAction(
    AcquisitionActionTypes.LOAD_ALL_ACQUISITIONS

);
export const loadAllAcquisitionsSuccess = createAction(
    AcquisitionActionTypes.LOAD_ALL_ACQUISITIONS_SUCCESS,
    props<{ acquisitions: Acquisition[] }>()
);

export const failure = createAction(
    AcquisitionActionTypes.ACQUISITION_FAILED,
    props<{ err: { concern: 'GET', error: any } }>()
);



