import { Injectable } from '@angular/core';
import {
    map,
    startWith,
    switchMap
} from 'rxjs/operators';
import { Actions, createEffect, Effect, ofType } from '@ngrx/effects';
import { AcquisitionsService } from 'src/app/shared/services/acquisitions.service';
import {
    loadAllAcquisitions,
    loadAllAcquisitionsSuccess,
    failure
} from 'src/app/shared/state/acquisition/acquisition.actions';

@Injectable()
export class AcquisitionsEffects {

    loadAll$ = createEffect(() => this.actions$.pipe(
        ofType(loadAllAcquisitions),
        startWith(loadAllAcquisitions()),
        switchMap(() => this.acquisitionsService.getAllAcquisitions().pipe(
            map(acquisitions => loadAllAcquisitionsSuccess({ acquisitions }))
        )),
    ));

    constructor(
        private actions$: Actions,
        private acquisitionsService: AcquisitionsService
    ) { }


}
