import { loadAllAcquisitionsSuccess } from 'src/app/shared/state/acquisition/acquisition.actions';
import { State } from 'src/app/shared/state/acquisition/acquisition.state';
import { EntityAdapter, createEntityAdapter } from '@ngrx/entity';
import { Acquisition } from 'src/app/shared/models/acquisition.model';
import { createReducer, on } from '@ngrx/store';


export const acquisitionsAdapter: EntityAdapter<Acquisition> = createEntityAdapter<Acquisition>({
    selectId: (acquisition: Acquisition) => acquisition.id,
    sortComparer: false
});


export const acquisitionsInitialState: State = {
    ids: [],
    entities: { 1: {} as Acquisition }
};
export const acquisitionReducer = createReducer<State>(
    acquisitionsInitialState,
    on(loadAllAcquisitionsSuccess, (state, { acquisitions }) =>
        acquisitionsAdapter.setAll(acquisitions, state))
);
export const getAcquisitionById = (id: number) => (state: State) => state.entities[id];

export const getAcquisitionsByName = (acqName: string) => (state: State) => {

    return Object.values(state.entities).find((acq) => acq.signal === acqName);
};
