import { Injectable } from '@angular/core';
import { select, Store } from '@ngrx/store';
import * as fromselector from 'src/app/shared/state/acquisition';
import { State } from 'src/app/shared/state/acquisition/acquisition.state';
import { NGXLogger } from 'ngx-logger';

@Injectable()
export class AcquisitionsStoreFacade {

    acquisitions$ = this.store.pipe(
        select(fromselector.getAllAcquisitions)
    );

    constructor(private store: Store<State>, private logger: NGXLogger) {
        this.logger.trace('My store acqs');

    }

    getAcquisitionById(id: number) {
        this.logger.trace('getAcqById ' + id);
        return this.store.pipe(
            select(fromselector.getAcquisitionById(id))
        );
    }

    getAcquisitionsByName(signalName: string) {
        this.logger.trace('getAcquisitionsByName ' + signalName);
        return this.store.pipe(
            select(fromselector.getAcquisitionsByName(signalName))
        );
    }
}
