import { createAction, props } from '@ngrx/store';
import { Alarm } from 'src/app/shared/models/alarm.model';

export enum AlarmActionTypes {
    LOAD_ALL_ALARMS = '[Alarm] Load all alarms',
    LOAD_ALL_ALARMS_SUCCESS = '[Alarm] Load all alarms success',
    ALARM_FAILED = '[Alarm] failure',
    UPDATE_ALARM = '[Alarm] Update alarm',
    UPDATE_ALARM_SUCCESS = '[Alarm] Update alarm success'

}
export const loadAllAlarms = createAction(
    AlarmActionTypes.LOAD_ALL_ALARMS

);
export const loadAllAlarmsSuccess = createAction(
    AlarmActionTypes.LOAD_ALL_ALARMS_SUCCESS,
    props<{ alarms: Alarm[] }>()
);

export const failure = createAction(
    AlarmActionTypes.ALARM_FAILED,
    props<{ err: { concern: 'GET' | 'UPDATE', error: any } }>()
);
export const updateAlarm = createAction(
    AlarmActionTypes.UPDATE_ALARM,
    props<{ alarm: Alarm }>()
);

export const updateAlarmSuccess = createAction(
    AlarmActionTypes.UPDATE_ALARM_SUCCESS,
    props<{ alarm: Partial<Alarm> }>()
);


