import { loadAllAlarmsSuccess, updateAlarmSuccess } from 'src/app/shared/state/alarm/alarm.actions';
import { State } from 'src/app/shared/state/alarm/alarm.state';
import { EntityAdapter, createEntityAdapter } from '@ngrx/entity';
import { Alarm } from 'src/app/shared/models/alarm.model';
import { createReducer, on } from '@ngrx/store';


export const alarmsAdapter: EntityAdapter<Alarm> = createEntityAdapter<Alarm>({
    selectId: (alarm: Alarm) => alarm.id,
    sortComparer: false
});


export const alarmsInitialState: State = {
    ids: [],
    entities: { 1: {} as Alarm }
};
export const alarmReducer = createReducer<State>(
    alarmsInitialState,
    on(loadAllAlarmsSuccess, (state, { alarms }) =>
        alarmsAdapter.setAll(alarms, state)),

    on(updateAlarmSuccess, (state, { alarm }) => {
        return alarmsAdapter.updateOne({ id: alarm.id, changes: alarm }, state);
    }),
);
export const getAlarmById = (id: number) => (state: State) => state.entities[id];
