import { Injectable } from '@angular/core';
import { select, Store } from '@ngrx/store';
import * as fromselector from 'src/app/shared/state/alarm';
import { State } from 'src/app/shared/state/alarm/alarm.state';
import { updateAlarm } from 'src/app/shared/state/alarm/alarm.actions';
import { Alarm } from 'src/app/shared/models/alarm.model';
import { NGXLogger } from 'ngx-logger';

@Injectable()
export class AlarmsStoreFacade {

    alarms$ = this.store.pipe(
        select(fromselector.getAllAlarms)
    );

    constructor(private store: Store<State>, private logger: NGXLogger) {
        this.logger.trace('My store alarms');
        this.logger.debug(store);
    }

    getAlarmById(id: number) {
        this.logger.trace('getAlarmById ' + id);
        return this.store.pipe(
            select(fromselector.getAlarmById(id))
        );
    }
    updateAlarm(alarm: Alarm) {
        this.store.dispatch(updateAlarm({ alarm }));
    }
}
