import { createAction, props } from '@ngrx/store';
import { Command } from 'src/app/shared/models/command.model';

export enum CommandActionTypes {
    LOAD_ALL_COMMANDS = '[Command] Load all commands',
    LOAD_ALL_COMMANDS_SUCCESS = '[Command] Load all commands success',
    COMMAND_FAILED = '[Command] failure',
    UPDATE_COMMAND = '[Command] Update command',
    UPDATE_COMMAND_SUCCESS = '[Command] Update command success'

}
export const loadAllCommands = createAction(
    CommandActionTypes.LOAD_ALL_COMMANDS

);
export const loadAllCommandsSuccess = createAction(
    CommandActionTypes.LOAD_ALL_COMMANDS_SUCCESS,
    props<{ commands: Command[] }>()
);

export const failure = createAction(
    CommandActionTypes.COMMAND_FAILED,
    props<{ err: { concern: 'GET' | 'UPDATE', error: any } }>()
);
export const updateCommand = createAction(
    CommandActionTypes.UPDATE_COMMAND,
    props<{ command: Command }>()
);

export const updateCommandSuccess = createAction(
    CommandActionTypes.UPDATE_COMMAND_SUCCESS,
    props<{ command: Partial<Command> }>()
);


