import { Injectable } from '@angular/core';
import { select, Store } from '@ngrx/store';
import * as fromselector from 'src/app/shared/state/command';
import { State } from 'src/app/shared/state/command/command.state';
import { updateCommand } from 'src/app/shared/state/command/command.actions';
import { Command } from 'src/app/shared/models/command.model';
import { NGXLogger } from 'ngx-logger';

@Injectable()
export class CommandsStoreFacade {

    commands$ = this.store.pipe(
        select(fromselector.getAllCommands)
    );

    constructor(private store: Store<State>, private logger: NGXLogger) {
        this.logger.trace('My store cmds');
        this.logger.debug(store);
    }

    getCommandById(id: number) {
        this.logger.trace('getAcqById ' + id);
        return this.store.pipe(
            select(fromselector.getCommandById(id))
        );
    }

    getCommandsByName(signalName: string) {
        this.logger.trace('getCommandsByName ' + signalName);
        return this.store.pipe(
            select(fromselector.getCommandsByName(signalName))
        );
    }
    updateCommand(command: Command) {
        this.store.dispatch(updateCommand({ command }));
    }
}
