import { createAction, props } from '@ngrx/store';
import { Event } from 'src/app/shared/models/event.model';

export enum EventActionTypes {
    LOAD_ALL_EVENTS = '[Event] Load all events',
    LOAD_ALL_EVENTS_SUCCESS = '[Event] Load all events success',
    EVENT_FAILED = '[Event] failure',
    ADD_EVENT = '[Event] Add event',
    ADD_EVENT_SUCCESS = '[Event] Update event success'

}
export const loadAllEvents = createAction(
    EventActionTypes.LOAD_ALL_EVENTS

);
export const loadAllEventsSuccess = createAction(
    EventActionTypes.LOAD_ALL_EVENTS_SUCCESS,
    props<{ events: Event[] }>()
);

export const failure = createAction(
    EventActionTypes.EVENT_FAILED,
    props<{ err: { concern: 'GET' | 'ADD', error: any } }>()
);
export const addEvent = createAction(
    EventActionTypes.ADD_EVENT,
    props<{ event: Event }>()
);

export const addEventSuccess = createAction(
    EventActionTypes.ADD_EVENT_SUCCESS,
    props<{ event: Partial<Event> }>()
);


