import { loadAllEventsSuccess, addEventSuccess } from 'src/app/shared/state/event/event.actions';
import { State } from 'src/app/shared/state/event/event.state';
import { EntityAdapter, createEntityAdapter } from '@ngrx/entity';
import { Event } from 'src/app/shared/models/event.model';
import { createReducer, on } from '@ngrx/store';


export const eventsAdapter: EntityAdapter<Event> = createEntityAdapter<Event>({
    selectId: (event: Event) => event.id,
    sortComparer: false
});


export const eventsInitialState: State = {
    ids: [],
    entities: { 1: {} as Event }
};
export const eventReducer = createReducer<State>(
    eventsInitialState,
    on(loadAllEventsSuccess, (state, { events }) =>
        eventsAdapter.setAll(events, state)),

    on(addEventSuccess, (state, { event }) => {
        return eventsAdapter.updateOne({ id: event.id, changes: event }, state);
    }),
);
export const getEventById = (id: number) => (state: State) => state.entities[id];
