import { Injectable } from '@angular/core';
import { select, Store } from '@ngrx/store';
import * as fromselector from 'src/app/shared/state/event';
import { State } from 'src/app/shared/state/event/event.state';
import { addEvent } from 'src/app/shared/state/event/event.actions';
import { Event } from 'src/app/shared/models/event.model';
import { NGXLogger } from 'ngx-logger';

@Injectable()
export class EventsStoreFacade {

    events$ = this.store.pipe(
        select(fromselector.getAllEvents)
    );

    constructor(private store: Store<State>, private logger: NGXLogger) {
        this.logger.trace('My store events');
        this.logger.debug(store);
    }

    getEventById(id: number) {
        this.logger.trace('getEventById ' + id);
        return this.store.pipe(
            select(fromselector.getEventById(id))
        );
    }
    addEvent(event: Event) {
        this.store.dispatch(addEvent({ event }));
    }
}
